<template>
  <v-list-tile @click="$emit('click', $event)">
    <v-list-tile-action>
      <v-icon>mdi-card-text</v-icon>
    </v-list-tile-action>
    <v-list-tile-content>
      <v-list-tile-title>{{ number }}</v-list-tile-title>
      <v-list-tile-sub-title>{{ money }}</v-list-tile-sub-title>
    </v-list-tile-content>
    <v-spacer/>

    <v-btn icon title="Empty Card" @click="$refs.emptyCardDialog.open()">
      <v-icon>mdi-close</v-icon>
    </v-btn>
    <v-btn icon title="Add Credits" @click="$refs.addCreditsDialog.open()">
      <v-icon>mdi-cash</v-icon>
    </v-btn>

    <empty-card-dialog ref="emptyCardDialog" :number="this.card && this.card.number"/>
    <add-credits-to-card-dialog ref="addCreditsDialog" :number="this.card && this.card.number"/>
  </v-list-tile>
</template>

<script>
import gql from "graphql-tag";
import AddCreditsToCardDialog from "@/components/dialogs/AddCreditsToCardDialog";
import EmptyCardDialog from "@/components/dialogs/EmptyCardDialog";

export default {
  name: "card-list-item",
  components: {
    AddCreditsToCardDialog,
    EmptyCardDialog
  },
  props: {
    id: { type: String, required: true }
  },
  data() {
    return {
      card: null // Dialogs
    };
  },
  computed: {
    number() {
      if (!this.card) return null;
      return `${Math.floor(this.card.number / 1000)}-${this.card.number %
        1000}`;
    },
    money() {
      if (!this.card || (!this.card.money && this.card.money !== 0))
        return null;
      let integer = Math.floor(this.card.money / 100);
      let cents = this.card.money % 100;

      if (cents < 10) cents = "0" + cents;

      return `R$ ${integer},${cents}`;
    }
  },
  apollo: {
    card: {
      query: gql`
        query($id: ID!) {
          card(id: $id) {
            id
            number
            money
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription($id: ID!) {
            card(id: $id) {
              id
              number
              money
            }
          }
        `,
        variables() {
          return {
            id: this.id
          };
        }
      },
      variables() {
        return {
          id: this.id
        };
      }
    }
  },
  methods: {
    async emptyCard() {
      const result = await this.$apollo.mutate({
        mutation: gql`
          mutation($number: Int!) {
            emptyCredits(cardNumber: $number) {
              id
            }
          }
        `,
        variables: {
          number: this.card && this.card.number
        }
      });
    }
  }
};
</script>
